import astropy,os,scipy,scipy.ndimage
#import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits
import ephem as ep
from astropy.coordinates import ICRS, Galactic
from astropy import units as u
from pylab import *
from astropy.time import Time

crosstalk=np.empty((16,16),dtype=np.float64)

f=open('../crosstalk_g.dat')
for k in range(16):
    f.readline()
    s=f.readline()
    s=s.strip("\n")
    arr=s.split(' ')
    for j in range(16):
        crosstalk[k,j]=arr[j]

#struct = np.empty((16,4032,4096),dtype=np.float32)

#struct[0,:,:]=fits.open('../struct-ccd1-g-image.fits')[0].data
#struct[1,:,:]=fits.open('../struct-ccd2-g-image.fits')[0].data
#struct[2,:,:]=fits.open('../struct-ccd3-g-image.fits')[0].data
#struct[3,:,:]=fits.open('../struct-ccd4-g-image.fits')[0].data

os.system('ls p????.*.fits > fits.lst')

for filename in open('fits.lst'):
    filename=filename.strip("\n")

    object=fits.open(filename)
    xx=int(object[1].header['NAXIS1'])
    yy=int(object[1].header['NAXIS2'])
    data=np.empty((16,yy,xx),dtype=np.float32)
    data1=np.empty((16,yy,xx),dtype=np.float32)

    for i in range(16):
        data[i]=object[i+1].data
        data1=data

    for i in range(16):
        for j in range(16):
            if (i==5) or (i==8):
                data1[i][:2048,1:2016]=data1[i][:2048,1:2016]-data[j][:2048,:2015]*crosstalk[j,i]
            else:
                data1[i]=data1[i]-data[j]*crosstalk[j,i]

    for i in range(16):
        object[i+1].data=data1[i]

    sky=np.empty((17,2068,2036),dtype=np.float32)

    for j in range(4):
        flat_median=np.empty((4))
        sub_median=np.empty((5,5))
        sub_mean=np.empty((5,5))
        sub_std=np.empty((5,5))
        n1 = np.empty((4096,4032),dtype=np.float32)
        n2 = np.empty((4032,4096),dtype=np.float32)
        nsky1=np.empty((4096,4032),dtype=np.float32)
        nsky2=np.empty((4032,4096),dtype=np.float32)

        hdu = fits.PrimaryHDU(n2)
        hdu_sky = fits.PrimaryHDU(nsky2)

        for k in range(4):
#            sky[j*4+k+1]=object[j*4+k+1].data

#            for i in range(16):
#                data1[j*4+k]=data1[j*4+k]-object[i+1].data*crosstalk[i,j*4+k]

#                if (j == 2) and (k == 2):
#                    print i,crosstalk[i,j*4+k],data1[i][1652,835]

#            print object[j*4+k+1].data[1693,1876]
            
            for m in range(5):
                for n in range(5):
                    if (m > -1) or (n > -1):
                        sub_median[m,n]=np.median(data1[j*4+k,m*400+30:(m+1)*400+30,n*400+10:(n+1)*400+10])
                        sub_mean[m,n]=np.median(data1[j*4+k,m*400+30:(m+1)*400+30,n*400+10:(n+1)*400+10])
                        sub_std[m,n]=np.std(data1[j*4+k,m*400+30:(m+1)*400+30,n*400+10:(n+1)*400+10])

            flat_median[k]=np.median(sub_median)

            sum=0.0
            l=0
            for m in range(5):
                for n in range(5):
                    if (m > -1) or (n > -1):
 #                       print(m,n,sub_std[m,n],100.*np.sqrt(np.median(data1[j*4+k,m*400+30:(m+1)*400+30,n*400+10:(n+1)*400+10])))
                        if (sub_std[m,n] < 100.*np.sqrt(np.median(data1[j*4+k,m*400+30:(m+1)*400+30,n*400+30:(n+1)*400+30]))):
#                    if ((sub_median[m,n]-flat_median[k]) < 0.):
                            sum+=sub_median[m,n]
                            l+=1
            
#            print(l)
            flat_median[k]=sum/l

#        print('CCD  ',j*4+k+1,flat_median[k],np.std(sub_median))

#        fig, ax = plt.subplots()
#        cax = ax.imshow(sub_median, interpolation='nearest')
#        cbar = fig.colorbar(cax)
#        plt.show()
#        raw_input()

#    hdu.header=object[0].header#+object[1].header
#    hdu.header+=object[j*4+1].header[9:10]+object[j*4+1].header[24:28]+object[j*4+1].header[29:41]#+object[1].header[42:56]
#    hdu.header.update('CCDSIZE','[1:4032,1:4096]',comment='CCD size',after='DETSIZE')
#    hdu.header.update('BIASSEC','[4033:4072,1:4096]',comment='Bias section',after='CCDSIZE')
#    hdu.header.update('DATASEC','[1:4032,1:4096]',comment='Data section',after='BIASSEC')
#    hdu.header.update('TRIMSEC','[1:4032,1:4096]',comment='Trim section',after='DATASEC')
#    hdu.header.add_comment('==================================================================',after='BUNIT')
#    hdu.header.add_comment('Image')
#    hdu.header.add_comment('==================================================================')
#    hdu.header+=object[j*4+1].header[44:56]
#    hdu.header.add_comment('==================================================================',after='DTV2')
#    hdu.header.add_comment('WCS')
#    hdu.header.add_comment('==================================================================')

        readnoise=object[0].header['RDNOIS'+str(j*4+1)]+' '+object[0].header['RDNOIS'+str(j*4+2)]+' '+object[0].header['RDNOIS'+str(j*4+3)]+' '+object[0].header['RDNOIS'+str(j*4+4)]
        rdcom='1 3 (e-) for amp id: '+str(j*4+1)+' '+str(j*4+2)+' '+str(j*4+3)+' '+str(j*4+4)

        gain=object[0].header['GAIN'+str(j*4+1)]+' '+object[0].header['GAIN'+str(j*4+2)]+' '+object[0].header['GAIN'+str(j*4+3)]+' '+object[0].header['GAIN'+str(j*4+4)]
        gcom='2 4 (e-/DN) for amp id: '+str(j*4+1)+' '+str(j*4+2)+' '+str(j*4+3)+' '+str(j*4+4)

        obcom='OPERATOR='+'\''+object[0].header['OPERATOR']+'\''
        sitecom='SITELAT = '+'\''+object[0].header['SITELAT']+'\' SITELONG = '+' \'-'+object[0].header['SITELONG']+'\''

        hdu.header=object[0].header[0:2]
        hdu.header['RA-OBS']=(object[0].header['RA'],'right ascension (2000.)')
        hdu.header['DEC-OBS']=(object[0].header['DEC'],'declination')
        hdu.header['CCD_NO']=j+1
        hdu.header['DATE-OBS']=(object[0].header['DATE-OBS'],'UTC shutter opened')
        hdu.header['TIME-OBS']=(object[0].header['TIME-OBS'],'UTC at start of exposure')
        hdu.header['TIMESYS']=(object[0].header['TIMESYS'],'Time system')
        hdu.header['EXPTIME']=(object[0].header['EXPTIME'],'Exposure time (seconds)')
        hdu.header['RA']=('','right ascension (2015.0)')
        hdu.header['DEC']=('','declination (2015.0)')
        hdu.header['HA']=(object[0].header['HA'],'hour angle')
        hdu.header['ST']=(object[0].header['ST'],'local siderial time')
        hdu.header['EPOCH']=(2015.0,'equinox of RA and DEC')
        hdu.header['FILTER']=(object[0].header['FILTER'],'Filter name')
        hdu.header['FOCUSVAL']=(object[0].header['FOCUSVAL'],'Focus')
        hdu.header['OBJECT']=object[0].header['OBJECT']
        hdu.header['IMAGETYP']=object[0].header['IMAGETYP']
        hdu.header['INSTRUME']=(object[0].header['INSTRUME'],'Instrument name')
        hdu.header['RDNOISE']=(readnoise,rdcom)
        hdu.header['GAIN']=(gain,gcom)
        hdu.header['FILENAME']=(object[0].header['FILENAME'],'FLATFILE')
        hdu.header['OBSERVER']=(object[0].header['OBSERVER'],obcom)
        hdu.header['SITEELEV']=(object[0].header['SITEELEV'],sitecom)
        hdu.header['CAMTEMP']=(object[0].header['CAMTEMP'],'Camera temperature in C')
        hdu.header['DEWTEMP']=(object[0].header['DEWTEMP'],'Dewar temperature in C')
        hdu.header['READ_SPD']=(object[0].header['READ_SPD'],'Readout speed (kpixel/sec/amp)')

        temp='INSIDE DOME: TEMP_F='+object[0].header['TEMPS1'][0:4]+' HUMID_%='+object[0].header['TEMPS1'][5:7]+' DEWPOINT_F='+object[0].header['TEMPS1'][8:12]
        hdu.header['TEMPS1']=(temp,'Temps')
        if ('WEATHER0' in hdu.header):
            hdu.header['WEATHER0']=(object[0].header['WEATHER0'],'WIND_SPEED_MPH')
        hdu.header['CALIBRU4']=''
        hdu.header['CALIBRAT']=''
        hdu.header['RDNOCAL']=''
        hdu.header['GAINCAL']=''

################################ Moon & Coord

        eq=ep.Equatorial(hdu.header['RA-OBS'],hdu.header['DEC-OBS'])
        eq1=ep.Equatorial(eq,epoch="2015.0")
        ga=ep.Galactic(eq)
        ec=ep.Ecliptic(eq)
#    print eq.ra,eq.dec,ga.long,ga.lat
#    print eq1.ra,eq1.dec,repr(eq1.dec*180./np.pi)
        eq_ra=repr(eq.ra*180./np.pi)
        eq_dec=repr(eq.dec*180./np.pi)
        eq1_ra=repr(eq1.ra*180./np.pi)
        eq1_dec=repr(eq1.dec*180./np.pi)
        ga_l=repr(ga.long*180./np.pi)
        ga_b=repr(ga.lat*180./np.pi)
        ec_l=repr(ec.long*180./np.pi)
        ec_b=repr(ec.lat*180./np.pi)

        kpno = ep.Observer()
        kpno.long = '-'+object[0].header['SITELONG']
        kpno.lat = object[0].header['SITELAT']
        kpno.elevation = float(object[0].header['SITEELEV'])
        kpno.date = object[0].header['DATE']+' '+object[0].header['TIME-OBS']
        star = ep.FixedBody()
        star._ra = ep.hours(eq.ra)
        star._dec = ep.degrees(eq.dec)
        star.compute(kpno)

        if (j==0) or (j==1):
            nflag=3
        else:
            nflag=2

#    hdu.header=hdu.header+object[j*4+nflag].header[44:48]
        hdu.header+=object[j*4+nflag].header[44:48]+object[j*4+nflag].header[49:50]+object[j*4+nflag].header[48:49]+object[j*4+nflag].header[50:56]
        hdu.header['EQUINOX'] =(2000,'Equinox of WCS')
        hdu.header['WCSDIM'] =(2,'WCS Dimensionality')
        hdu.header['CTYPE1']=(object[j*4+nflag].header['CTYPE2'],'l_sun='+str(round(float(ec_l),2)))
        hdu.header['CTYPE2']=(object[j*4+nflag].header['CTYPE1'],'b_sun='+str(round(float(ec_b),2)))

        hdu.header['CRVAL1']=(object[j*4+nflag].header['CRVAL2'],'l_gal='+str(round(float(ga_l),2)))
        hdu.header['CRVAL2']=(object[j*4+nflag].header['CRVAL1'],'b_gal='+str(round(float(ga_b),2)))

        saz=star.az*180./np.pi
        salt=star.alt*180./np.pi
    
        hdu.header['CRPIX1']=(object[j*4+nflag].header['CRPIX2'],'Azimuth='+str(round(saz,2)))
        hdu.header['CRPIX2']=(object[j*4+nflag].header['CRPIX1'],'Altitude='+str(round(salt,2)))

        hdu.header['CD1_1']=object[j*4+nflag].header['CD1_1']*-1
        hdu.header['CD2_2']=object[j*4+nflag].header['CD2_2']*-1
    
        hdu.header['CD1_2']=0
        hdu.header['CD2_1']=0

        airmass=1/np.cos((90.-salt)*np.pi/180.)
        airmass=airmass*(1-0.0012*(airmass**2.-1))
        hdu.header['AIRMASS']=round(airmass,3)

        moon=ep.Moon()
        sun=ep.Sun()
        moon.compute(kpno)
        distance=ep.separation(star,moon)*180./np.pi
        moon_az=moon.az*180./np.pi
        moon_alt=moon.alt*180./np.pi

        hdu.header['MPHASE']=(round(moon.phase,1),'Define the length of Moon_Month 29.53d')
        hdu.header['MAZIMUTH']=(round(moon_az,2),'Moon Azimuth is measured from south thr. west')
        hdu.header['MALITIUD']=(round(moon_alt,2),'both units in degrees')
        hdu.header['MANGLE']=(round(distance,2),'Position angle of Moon to CCD_Field center ')

        hdu.header.add_comment('==================================================================',after='GAINCAL')
        hdu.header.add_comment('WCS')
        hdu.header.add_comment('==================================================================')

        flat_mean=np.mean(flat_median)

        if (j==0) or (j==1):
            flag=np.arange(1,5)
#            flag=np.linspace(1,4,4)
        else:
            flag=np.arange(4,0,-1)
#            flag=np.linspace(4,1,4)

#    print object[j*4+k+1].data[2000,2000],np.median(nsky1),sky[j*4+k+1,2000,2000]

        sum=0.0
        for k in range(4):
            object[j*4+k+1].data[:,:2016]=object[j*4+k+1].data[:,:2016]/flat_median[k]*flat_mean
        
#        for k in range(4):
#            print(sum,np.median(object[j*4+k+1].data[:2048,2010:2015]),np.median(object[j*4+k+1].data[2042:2047,:2016]))
        median1=np.median(object[j*4+1].data[:2048,1950:2000])
        median2=np.median(object[j*4+2].data[:2048,1950:2000])
        median3=np.median(object[j*4+3].data[:2048,1950:2000])
        median4=np.median(object[j*4+4].data[:2048,1950:2000])
#        print(j*4+1,median1,median2,median3,median4)

        object[j*4+1].data[:,:2016]=object[j*4+1].data[:,:2016]-median1+(median1+median2)/2.
        object[j*4+2].data[:,:2016]=object[j*4+2].data[:,:2016]-median2+(median1+median2)/2.
        object[j*4+3].data[:,:2016]=object[j*4+3].data[:,:2016]-median3+(median3+median4)/2.
        object[j*4+4].data[:,:2016]=object[j*4+4].data[:,:2016]-median4+(median3+median4)/2.

        median1=np.median(object[j*4+1].data[2042:2047,:2016])
        median2=np.median(object[j*4+2].data[2042:2047,:2016])
        median3=np.median(object[j*4+3].data[2042:2047,:2016])
        median4=np.median(object[j*4+4].data[2042:2047,:2016])

        xmedian=0.25*(median1+median2+median3+median4)

#        print median1,median2,median3,median4                  
        object[j*4+1].data[:2048,:2016]=object[j*4+1].data[:2048,:2016]-(median1+median2)/2.+xmedian
        object[j*4+2].data[:2048,:2016]=object[j*4+2].data[:2048,:2016]-(median1+median2)/2.+xmedian
        object[j*4+3].data[:2048,:2016]=object[j*4+3].data[:2048,:2016]-(median3+median4)/2.+xmedian
        object[j*4+4].data[:2048,:2016]=object[j*4+4].data[:2048,:2016]-(median3+median4)/2.+xmedian

        for k in range(4):
            sum=sum+(np.median(object[j*4+k+1].data[:2048,2014:2016])+np.median(object[j*4+k+1].data[2046:2048,:2016]))/2.

        sum=sum/4.

#            if (k == 2):
#                object[j*4+k+1].data[:,:2016]-=2.
#            print np.median(object[j*4+k+1].data[1800:1900,1800:1900]),np.median(object[j*4+k+1].data[100:1900,100:1900])

#        print object[j*4+k+1].data[2000,2000],np.median(nsky1),sky[j*4+k+1,2000,2000]

        n1[0:2048,0:2016]=object[j*4+flag[0]].data[0:2048,0:2016]
#    n1[0:2048,4032:4052]=object[j*4+flag[0]].data[0:2048,2016:2036]
        s=object[j*4+flag[1]].data[0:2048,::-1]
        n1[0:2048,2016:4032]=s[0:2048,20:2036]
#    n1[0:2048,4052:4072]=object[j*4+flag[1]].data[0:2048,2016:2036]
        s=object[j*4+flag[2]].data[::-1,::]
        if (yy==2048):
            n1[2048:4096,0:2016]=s[0:2048,0:2016]
        else:
            n1[2048:4096,0:2016]=s[20:2068,0:2016]
#    n1[2048:4096,4032:4052]=object[j*4+flag[2]].data[0:2048,2016:2036]
        s=object[j*4+flag[3]].data[::-1,::-1]
        if (yy==2048):
            n1[2048:4096,2016:4032]=s[0:2048,20:2036]
        else:
            n1[2048:4096,2016:4032]=s[20:2068,20:2036]
#    n1[2048:4096,4052:4072]=object[j*4+flag[3]].data[0:2048,2016:2036]
#        print n1[0,4031],n1[4095,0],n1[4095,4031],n1[0,0]
#        n2=scipy.ndimage.interpolation.rotate(n1,angle=-90)#*struct[j,:,:]
        n2=np.rot90(n1,3)##*struct[j,:,:]
#        print n2[4031,0],n2[0,4095],n2[4031,4095],n2[0,0]
        hdu.data=n2

#        nsky1[0:2048,0:2016]=sky[j*4+flag[0],0:2048,0:2016]
#    nsky1[0:2048,4032:4052]=sky[j*4+flag[0],0:2048,2016:2036]
#        s=sky[j*4+flag[1],0:2048,::-1]
#        nsky1[0:2048,2016:4032]=s[0:2048,20:2036]
#    nsky1[0:2048,4052:4072]=sky[j*4+flag[1],0:2048,2016:2036]
#        s=sky[j*4+flag[2],::-1,::]
#        nsky1[2048:4096,0:2016]=s[0:2048,0:2016]
#    nsky1[2048:4096,4032:4052]=sky[j*4+flag[2],0:2048,2016:2036]
#        s=sky[j*4+flag[3],::-1,::-1]
#        nsky1[2048:4096,2016:4032]=s[0:2048,20:2036]
#    nsky1[2048:4096,4052:4072]=sky[j*4+flag[3],0:2048,2016:2036]

#        nsky2=np.rot90(nsky1)
#        hdu_sky.data=nsky2
    
        hdu.header['SKYADU']=(round(np.median(n1),2),'(per pixel)')

        ttt=object[0].header['DATE']+'T'+object[0].header['TIME-OBS']

        time=Time(ttt)
        hdu.header['MJD_OBS']=round(time.mjd,5)

        hdu_sky.header=hdu.header

################################## write fits

        line='p'+filename[1:5]+hdu.header['FILTER']+filename[6:10]+'_'+str(j+1)+filename[10:]
#        line1='p'+filename[1:5]+hdu.header['FILTER']+filename[6:10]+'_'+str(j+1)+'_sky'+filename[10:]

        print(line)

        hdu.writeto(line,clobber=True)
#        hdu_sky.writeto(line1,clobber=True)
#    hdu.close()

    object.close()
